/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.28 from the
 * contents of EV.xs. Do not edit this file, edit EV.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "EV.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* fix perl api breakage */
#ifndef WIN32
# undef signal
# undef sigaction
#endif

#include "schmorp.h"

/* old API compatibility */
static int
sv_fileno (SV *fh)
{
  return s_fileno (fh, 0);
}

#ifndef GvCV_set
# define GvCV_set(gv,cv) GvCV (gv) = cv
#endif

#define EV_STANDALONE 1
#define EV_PROTOTYPES 1
#define EV_USE_NANOSLEEP EV_USE_MONOTONIC
#define EV_USE_FLOOR 1
#define EV_API_STATIC
#define EV_H <ev.h>
#define EV_CONFIG_H error
#include "EV/EVAPI.h"

#define EV_SELECT_IS_WINSOCKET 0
#ifdef _WIN32
# define EV_SELECT_USE_FD_SET 0
# define NFDBITS PERL_NFDBITS
# define fd_mask Perl_fd_mask
#endif
/* due to bugs in OS X we have to use libev/ explicitly here */
#include "libev/ev.c"

#if !defined _WIN32 && !defined _MINIX && !EV_NO_ATFORK
# include <pthread.h>
#endif

#define e_loop(w)  INT2PTR (struct ev_loop *, SvIVX (((ev_watcher *)(w))->loop))
#define e_flags(w) ((ev_watcher *)(w))->e_flags
#define e_self(w)  ((ev_watcher *)(w))->self
#define e_fh(w)    ((ev_watcher *)(w))->fh
#define e_data(w)  ((ev_watcher *)(w))->data

#define WFLAG_KEEPALIVE 1
#define WFLAG_UNREFED   2 /* has been unref'ed */

#define UNREF(w)				\
  if (!(e_flags (w) & (WFLAG_KEEPALIVE | WFLAG_UNREFED))	\
      && ev_is_active (w))			\
    {						\
      ev_unref (e_loop (w));			\
      e_flags (w) |= WFLAG_UNREFED;		\
    }

#define REF(w)					\
  if (e_flags (w) & WFLAG_UNREFED)		\
    {						\
      e_flags (w) &= ~WFLAG_UNREFED;		\
      ev_ref (e_loop (w));			\
    }

#define START(type,w)				\
  do {						\
    ev_ ## type ## _start (e_loop (w), w);	\
    UNREF (w);					\
  } while (0)

#define STOP(type,w)				\
  do {						\
    REF (w);					\
    ev_ ## type ## _stop (e_loop (w), w);	\
  } while (0)

#define RESET(type,w,seta)			\
  do {                                          \
    int active = ev_is_active (w);              \
    if (active) STOP (type, w);                 \
    ev_ ## type ## _set seta;                   \
    if (active) START (type, w);                \
  } while (0)

typedef int Signal;

/* horrible... */
#define CHECK_SIGNAL_CAN_START(w)		\
  do {						\
    /* dive into the internals of libev to avoid aborting in libev */ \
    if (signals [(w)->signum - 1].loop		\
        && signals [(w)->signum - 1].loop != e_loop (w)) \
      croak ("unable to start signal watcher, signal %d already registered in another loop", w->signum); \
  } while (0)

#define START_SIGNAL(w)				\
  do {						\
    CHECK_SIGNAL_CAN_START (w);			\
    START (signal, w);				\
  } while (0)					\

#define RESET_SIGNAL(w,seta)			\
  do {                                          \
    int active = ev_is_active (w);              \
    if (active) STOP (signal, w);               \
    ev_ ## signal ## _set seta;                 \
    if (active) START_SIGNAL (w);               \
  } while (0)

static SV *default_loop_sv;

static struct EVAPI evapi;

static HV
  *stash_loop,
  *stash_watcher,
  *stash_io,
  *stash_timer,
  *stash_periodic,
  *stash_signal,
  *stash_child,
  *stash_stat,
  *stash_idle,
  *stash_prepare,
  *stash_check,
  *stash_embed,
  *stash_fork,
  *stash_cleanup,
  *stash_async;

/////////////////////////////////////////////////////////////////////////////
// Event

static void e_cb (EV_P_ ev_watcher *w, int revents);

static void *
e_new (int size, SV *cb_sv, SV *loop)
{
  SV *cv = cb_sv ? s_get_cv_croak (cb_sv) : 0;
  ev_watcher *w;
  SV *self = NEWSV (0, size);
  SvPOK_only (self);
  SvCUR_set (self, size);

  w = (ev_watcher *)SvPVX (self);

  ev_init (w, cv ? e_cb : 0);

  w->loop    = SvREFCNT_inc (SvRV (loop));
  w->e_flags = WFLAG_KEEPALIVE;
  w->data    = 0;
  w->fh      = 0;
  w->cb_sv   = SvREFCNT_inc (cv);
  w->self    = self;

  return (void *)w;
}

static void
e_destroy (void *w_)
{
  ev_watcher *w = (ev_watcher *)w_;

  SvREFCNT_dec (w->loop ); w->loop  = 0;
  SvREFCNT_dec (w->fh   ); w->fh    = 0;
  SvREFCNT_dec (w->cb_sv); w->cb_sv = 0;
  SvREFCNT_dec (w->data ); w->data  = 0;
}

static SV *
e_bless (ev_watcher *w, HV *stash)
{
  SV *rv;

  if (SvOBJECT (w->self))
    rv = newRV_inc (w->self);
  else
    {
      rv = newRV_noinc (w->self);
      sv_bless (rv, stash);
      SvREADONLY_on (w->self);
    }

  return rv;
}

static SV *sv_self_cache, *sv_events_cache;

static void
e_cb (EV_P_ ev_watcher *w, int revents)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_self, *sv_events;

  /* libev might have stopped the watcher */
  if (expect_false (w->e_flags & WFLAG_UNREFED)
      && !ev_is_active (w))
    REF (w);

  if (expect_true (sv_self_cache))
    {
      sv_self = sv_self_cache; sv_self_cache = 0;
      SvRV_set (sv_self, SvREFCNT_inc_NN (w->self));
    }
  else
    {
      sv_self = newRV_inc (w->self); /* e_self (w) MUST be blessed by now */
      SvREADONLY_on (sv_self);
    }

  if (expect_true (sv_events_cache))
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
      SvIOK_only (sv_events);
    }
  else
    {
      sv_events = newSViv (revents);
      SvREADONLY_on (sv_events);
    }

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (sv_self);
  PUSHs (sv_events);

  PUTBACK;
  call_sv (w->cb_sv, G_DISCARD | G_VOID | G_EVAL);

  if (expect_false (SvREFCNT (sv_self) != 1 || sv_self_cache))
    SvREFCNT_dec (sv_self);
  else
    {
      SvREFCNT_dec (SvRV (sv_self));
      SvRV_set (sv_self, &PL_sv_undef);
      sv_self_cache = sv_self;
    }

  if (expect_false (SvREFCNT (sv_events) != 1 || sv_events_cache))
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (expect_false (SvTRUE (ERRSV)))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static void
e_once_cb (int revents, void *arg)
{
  dSP;
  I32 mark = SP - PL_stack_base;
  SV *sv_events;

  if (sv_events_cache)
    {
      sv_events = sv_events_cache; sv_events_cache = 0;
      SvIV_set (sv_events, revents);
    }
  else
    sv_events = newSViv (revents);

  PUSHMARK (SP);
  XPUSHs (sv_events);

  PUTBACK;
  call_sv ((SV *)arg, G_DISCARD | G_VOID | G_EVAL);

  SvREFCNT_dec ((SV *)arg);

  if (sv_events_cache)
    SvREFCNT_dec (sv_events);
  else
    sv_events_cache = sv_events;

  if (SvTRUE (ERRSV))
    {
      SPAGAIN;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
    }

  SP = PL_stack_base + mark;
  PUTBACK;
}

static ev_tstamp
e_periodic_cb (ev_periodic *w, ev_tstamp now)
{
  ev_tstamp retval;
  int count;
  dSP;

  ENTER;
  SAVETMPS;

  PUSHMARK (SP);
  EXTEND (SP, 2);
  PUSHs (newRV_inc (e_self (w))); /* e_self (w) MUST be blessed by now */
  PUSHs (newSVnv (now));

  PUTBACK;
  count = call_sv (w->fh, G_SCALAR | G_EVAL);
  SPAGAIN;

  if (SvTRUE (ERRSV))
    {
      PUSHMARK (SP);
      PUTBACK;
      call_sv (get_sv ("EV::DIED", 1), G_DISCARD | G_VOID | G_EVAL | G_KEEPERR);
      SPAGAIN;
    }

  if (count > 0)
    {
      retval = SvNV (TOPs);

      if (retval < now)
        retval = now;
    }
  else
    retval = now;

  FREETMPS;
  LEAVE;

  return retval;
}

#define CHECK_REPEAT(repeat) if (repeat < 0.) \
  croak (# repeat " value must be >= 0");

#define CHECK_FD(fh,fd) if ((fd) < 0) \
  croak ("illegal file descriptor or filehandle (either no attached file descriptor or illegal value): %s", SvPV_nolen (fh));

#define CHECK_SIG(sv,num) if ((num) < 0) \
  croak ("illegal signal number or name: %s", SvPV_nolen (sv));

static void
default_fork (void)
{
  ev_loop_fork (EV_DEFAULT_UC);
}

/////////////////////////////////////////////////////////////////////////////
// XS interface functions

#line 374 "EV.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 518 "EV.c"

XS_EUPXS(XS_EV_default_loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_default_loop)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "flags= 0");
    {
	SV *	RETVAL;
	unsigned int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(0))
;
	}
#line 550 "EV.xs"
{
	if (!default_loop_sv)
          {
            evapi.default_loop = ev_default_loop (flags);

            if (!evapi.default_loop)
              XSRETURN_UNDEF;

            default_loop_sv = sv_bless (newRV_noinc (newSViv (PTR2IV (evapi.default_loop))), stash_loop);
          }

        RETVAL = newSVsv (default_loop_sv);
}
#line 550 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_default_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_default_destroy)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 568 "EV.xs"
        ev_loop_destroy (EV_DEFAULT_UC);
        SvREFCNT_dec (default_loop_sv);
        default_loop_sv = 0;
#line 569 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_supported_backends); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_supported_backends)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_supported_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_recommended_backends); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_recommended_backends)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_recommended_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_embeddable_backends); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_embeddable_backends)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_embeddable_backends();
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_sleep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_sleep)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0))
;

	ev_sleep(interval);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_time)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_time();
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_feed_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_feed_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "signal");
    {
	SV *	signal = ST(0)
;
#line 584 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal (signum);
}
#line 675 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_now); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_now)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	NV	RETVAL;
	dXSTARG;

	RETVAL = ev_now(evapi.default_loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_now_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_now_update)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_now_update(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_suspend)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_suspend(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_resume)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_resume(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_backend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_backend)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_backend(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_verify)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_verify(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_iteration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_iteration)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_iteration(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_depth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_depth)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_depth(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_set_io_collect_interval)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0))
;

	ev_set_io_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_set_timeout_collect_interval)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "interval");
    {
	NV	interval = (NV)SvNV(ST(0))
;

	ev_set_timeout_collect_interval(evapi.default_loop, interval);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_run)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "flags= 0");
    {
	int	RETVAL;
	dXSTARG;
	int	flags;

	if (items < 1)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(0))
;
	}

	RETVAL = ev_run(evapi.default_loop, flags);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_break); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_break)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "how= EVBREAK_ONE");
    {
	int	how;

	if (items < 1)
	    how = EVBREAK_ONE;
	else {
	    how = (int)SvIV(ST(0))
;
	}

	ev_break(evapi.default_loop, how);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_feed_fd_event)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "fd, revents= EV_NONE");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	revents;

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1))
;
	}

	ev_feed_fd_event(evapi.default_loop, fd, revents);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_feed_signal_event)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "signal");
    {
	SV *	signal = ST(0)
;
#line 642 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (evapi.default_loop, signum);
}
#line 929 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_pending_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_pending_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = ev_pending_count(evapi.default_loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_invoke_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_invoke_pending)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {

	ev_invoke_pending(evapi.default_loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV_io); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_io)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "fh, events, cb");
    {
	ev_io *	RETVAL;
	SV *	fh = ST(0)
;
	int	events = (int)SvIV(ST(1))
;
	SV *	cb = ST(2)
;
#line 660 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        if (ix == 2)
          {
            ix = 0;
            events = events ? EV_WRITE : EV_READ;
          }

        RETVAL = e_new (sizeof (ev_io), cb, default_loop_sv);
        e_fh (RETVAL) = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 997 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_io);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_timer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_timer)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "after, repeat, cb");
    {
	ev_timer *	RETVAL;
	NV	after = (NV)SvNV(ST(0))
;
	NV	repeat = (NV)SvNV(ST(1))
;
	SV *	cb = ST(2)
;
#line 682 "EV.xs"
        CHECK_REPEAT (repeat);
#line 1026 "EV.c"
#line 684 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, default_loop_sv);
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 1031 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_timer);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_periodic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_periodic)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "at, interval, reschedule_cb, cb");
    {
	SV *	RETVAL;
	NV	at = (NV)SvNV(ST(0))
;
	NV	interval = (NV)SvNV(ST(1))
;
	SV *	reschedule_cb = ST(2)
;
	SV *	cb = ST(3)
;
#line 694 "EV.xs"
        CHECK_REPEAT (interval);
#line 1062 "EV.c"
#line 696 "EV.xs"
{
	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, default_loop_sv);
        e_fh (w) = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, e_fh (w) ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 1072 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_signal)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "signal, cb");
    {
	ev_signal *	RETVAL;
	SV *	signal = ST(0)
;
	SV *	cb = ST(1)
;
#line 711 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, default_loop_sv);
        ev_signal_set (RETVAL, signum);
        if (!ix) START_SIGNAL (RETVAL);
}
#line 1102 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_signal);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_idle)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_idle *	RETVAL;
	SV *	cb = ST(0)
;
#line 726 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, default_loop_sv);
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 1129 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_idle);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_prepare)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_prepare *	RETVAL;
	SV *	cb = ST(0)
;
#line 736 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, default_loop_sv);
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 1156 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_check)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_check *	RETVAL;
	SV *	cb = ST(0)
;
#line 746 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, default_loop_sv);
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 1183 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_check);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_fork); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_fork)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_fork *	RETVAL;
	SV *	cb = ST(0)
;
#line 756 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, default_loop_sv);
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 1210 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_fork);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if CLEANUP_ENABLED
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_EV_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_cleanup)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_cleanup *	RETVAL;
	SV *	cb = ST(0)
;
#line 768 "EV.xs"
        RETVAL = e_new (sizeof (ev_cleanup), cb, default_loop_sv);
        SvREFCNT_dec (RETVAL->loop); /* must not keep loop object alive */
        ev_cleanup_set (RETVAL);
        if (!ix) START (cleanup, RETVAL);
#line 1241 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_cleanup);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_EV_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_child)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "pid, trace, cb");
    {
	ev_child *	RETVAL;
	int	pid = (int)SvIV(ST(0))
;
	int	trace = (int)SvIV(ST(1))
;
	SV *	cb = ST(2)
;
#line 781 "EV.xs"
#if EV_CHILD_ENABLE
        RETVAL = e_new (sizeof (ev_child), cb, default_loop_sv);
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#else
        croak ("EV::child watchers not supported on this platform");
#endif
#line 1277 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_child);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_stat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "path, interval, cb");
    {
	ev_stat *	RETVAL;
	SV *	path = ST(0)
;
	NV	interval = (NV)SvNV(ST(1))
;
	SV *	cb = ST(2)
;
#line 796 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, default_loop_sv);
        e_fh (RETVAL) = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (e_fh (RETVAL)), interval);
        if (!ix) START (stat, RETVAL);
#line 1309 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_stat);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifndef EV_NO_LOOPS
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_EV_embed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_embed)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, cb= 0");
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	if (items < 2)
	    cb = 0;
	else {
	    cb = ST(1)
;
	}
#line 809 "EV.xs"
{
        if (!(ev_backend (loop) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, default_loop_sv);
        e_fh (RETVAL) = newSVsv (ST (0));
        ev_embed_set (RETVAL, loop);
        if (!ix) START (embed, RETVAL);
}
#line 1358 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_embed);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_EV_async); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_async)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	ev_async *	RETVAL;
	SV *	cb = ST(0)
;
#line 827 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, default_loop_sv);
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 1386 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_async);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV_once); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV_once)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fh, events, timeout, cb");
    {
	SV *	fh = ST(0)
;
	int	events = (int)SvIV(ST(1))
;
	SV *	timeout = ST(2)
;
	SV *	cb = ST(3)
;
#line 835 "EV.xs"
        ev_once (
           evapi.default_loop,
           s_fileno (fh, events & EV_WRITE), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 1421 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Watcher_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	RETVAL = ev_is_active(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_is_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_is_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	RETVAL = ev_is_pending(w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_invoke); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_invoke)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, revents= EV_NONE");
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1))
;
	}

	ev_invoke(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Watcher_clear_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_clear_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	RETVAL = ev_clear_pending(e_loop (w), w);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_feed_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_feed_event)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, revents= EV_NONE");
    {
	ev_watcher *	w;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(1))
;
	}

	ev_feed_event(e_loop (w), w, revents);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Watcher_keepalive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_keepalive)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_value= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_value;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_value = 0;
	else {
	    new_value = (int)SvIV(ST(1))
;
	}
#line 862 "EV.xs"
{
        RETVAL = w->e_flags & WFLAG_KEEPALIVE;
        new_value = new_value ? WFLAG_KEEPALIVE : 0;

        if (items > 1 && ((new_value ^ w->e_flags) & WFLAG_KEEPALIVE))
          {
            w->e_flags = (w->e_flags & ~WFLAG_KEEPALIVE) | new_value;
            REF (w);
            UNREF (w);
          }
}
#line 1599 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_cb)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_cb= 0");
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_cb = 0;
	else {
	    new_cb = ST(1)
;
	}
#line 878 "EV.xs"
{
        if (items > 1)
          {
            new_cb = s_get_cv_croak (new_cb);
            RETVAL = newRV_noinc (w->cb_sv);
            w->cb_sv = SvREFCNT_inc (new_cb);
          }
        else
          RETVAL = newRV_inc (w->cb_sv);
}
#line 1641 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_data)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_data= 0");
    {
	SV *	RETVAL;
	ev_watcher *	w;
	SV *	new_data;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_data = 0;
	else {
	    new_data = ST(1)
;
	}
#line 893 "EV.xs"
{
	RETVAL = w->data ? newSVsv (w->data) : &PL_sv_undef;

        if (items > 1)
          {
            SvREFCNT_dec (w->data);
            w->data = newSVsv (new_data);
          }
}
#line 1683 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_loop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_loop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_watcher *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;
#line 907 "EV.xs"
	RETVAL = newRV_inc (w->loop);
#line 1709 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Watcher_priority); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Watcher_priority)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_priority= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	int	new_priority;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_priority = 0;
	else {
	    new_priority = (int)SvIV(ST(1))
;
	}
#line 913 "EV.xs"
{
        RETVAL = w->priority;

        if (items > 1)
          {
            int active = ev_is_active (w);

            if (active)
              {
                /* grrr. */
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("stop", G_DISCARD | G_VOID);
              }

            ev_set_priority (w, new_priority);

            if (active)
              {
                PUSHMARK (SP);
                XPUSHs (ST (0));
                PUTBACK;
                call_method ("start", G_DISCARD | G_VOID);
              }
          }
}
#line 1770 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__IO_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;
#line 947 "EV.xs"
        START (io, w);
#line 1794 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__IO_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;
#line 951 "EV.xs"
        STOP (io, w);
#line 1817 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__IO_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_io *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;
#line 955 "EV.xs"
        STOP (io, w);
        e_destroy (w);
#line 1841 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__IO_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "w, fh, events");
    {
	ev_io *	w;
	SV *	fh = ST(1)
;
	int	events = (int)SvIV(ST(2))
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;
#line 960 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        sv_setsv (e_fh (w), fh);
        RESET (io, w, (w, fd, events));
}
#line 1874 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__IO_fh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_fh)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_fh= 0");
    {
	SV *	RETVAL;
	ev_io *	w;
	SV *	new_fh;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_fh = 0;
	else {
	    new_fh = ST(1)
;
	}
#line 970 "EV.xs"
{
        if (items > 1)
          {
            int fd = s_fileno (new_fh, w->events & EV_WRITE);
            CHECK_FD (new_fh, fd);

            RETVAL = e_fh (w);
            e_fh (w) = newSVsv (new_fh);

            RESET (io, w, (w, fd, w->events));
          }
        else
          RETVAL = newSVsv (e_fh (w));
}
#line 1919 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__IO_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__IO_events)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_events= EV_UNDEF");
    {
	int	RETVAL;
	dXSTARG;
	ev_io *	w;
	int	new_events;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_io
                  || sv_derived_from (ST(0), "EV::Io"))))
          croak ("object is not of type EV::Io");
	w = (ev_io *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_events = EV_UNDEF;
	else {
	    new_events = (int)SvIV(ST(1))
;
	}
#line 989 "EV.xs"
{
        RETVAL = w->events;

        if (items > 1)
          RESET (io, w, (w, w->fd, new_events));
}
#line 1959 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Signal_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Signal_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)))
;
#line 1002 "EV.xs"
        START_SIGNAL (w);
#line 1983 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Signal_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Signal_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)))
;
#line 1006 "EV.xs"
        STOP (signal, w);
#line 2006 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Signal_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Signal_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_signal *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)))
;
#line 1010 "EV.xs"
        STOP (signal, w);
        e_destroy (w);
#line 2030 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Signal_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Signal_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "w, signal");
    {
	ev_signal *	w;
	SV *	signal = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)))
;
#line 1015 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RESET_SIGNAL (w, (w, signum));
}
#line 2060 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Signal_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Signal_signal)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_signal= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_signal *	w;
	SV *	new_signal;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_signal
                  || sv_derived_from (ST(0), "EV::Signal"))))
          croak ("object is not of type EV::Signal");
	w = (ev_signal *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_signal = 0;
	else {
	    new_signal = ST(1)
;
	}
#line 1024 "EV.xs"
{
        RETVAL = w->signum;

        if (items > 1)
          {
            Signal signum = s_signum (new_signal);
            CHECK_SIG (new_signal, signum);

            RESET_SIGNAL (w, (w, signum));
          }
}
#line 2103 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Timer_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;
#line 1042 "EV.xs"
        CHECK_REPEAT (w->repeat);
#line 2127 "EV.c"
#line 1044 "EV.xs"
        START (timer, w);
#line 2130 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Timer_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;
#line 1048 "EV.xs"
        STOP (timer, w);
#line 2153 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Timer_again); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_again)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, repeat= NO_INIT");
    {
	ev_timer *	w;
	NV	repeat;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;

	if (items >= 2) {
	    repeat = (NV)SvNV(ST(1))
;
	}
#line 1052 "EV.xs"
        if (items > 1)
          w->repeat = repeat;
        CHECK_REPEAT (w->repeat);
        ev_timer_again (e_loop (w), w);
        UNREF (w);
#line 2186 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Timer_remaining); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_remaining)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	NV	RETVAL;
	dXSTARG;
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;

	RETVAL = ev_timer_remaining(e_loop (w), w);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Timer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_timer *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;
#line 1063 "EV.xs"
        STOP (timer, w);
        e_destroy (w);
#line 2235 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Timer_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Timer_set)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "w, after, repeat= 0.");
    {
	ev_timer *	w;
	NV	after = (NV)SvNV(ST(1))
;
	NV	repeat;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_timer
                  || sv_derived_from (ST(0), "EV::Timer"))))
          croak ("object is not of type EV::Timer");
	w = (ev_timer *)SvPVX (SvRV (ST(0)))
;

	if (items < 3)
	    repeat = 0.;
	else {
	    repeat = (NV)SvNV(ST(2))
;
	}
#line 1068 "EV.xs"
        CHECK_REPEAT (repeat);
#line 2268 "EV.c"
#line 1070 "EV.xs"
        RESET (timer, w, (w, after, repeat));
#line 2271 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;
#line 1076 "EV.xs"
        CHECK_REPEAT (w->interval);
#line 2294 "EV.c"
#line 1078 "EV.xs"
        START (periodic, w);
#line 2297 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;
#line 1082 "EV.xs"
        STOP (periodic, w);
#line 2320 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_again); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_again)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;
#line 1086 "EV.xs"
        ev_periodic_again (e_loop (w), w);
        UNREF (w);
#line 2344 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;
#line 1091 "EV.xs"
        STOP (periodic, w);
        e_destroy (w);
#line 2368 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_set)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "w, at, interval= 0., reschedule_cb= &PL_sv_undef");
    {
	ev_periodic *	w;
	NV	at = (NV)SvNV(ST(1))
;
	NV	interval;
	SV *	reschedule_cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;

	if (items < 3)
	    interval = 0.;
	else {
	    interval = (NV)SvNV(ST(2))
;
	}

	if (items < 4)
	    reschedule_cb = &PL_sv_undef;
	else {
	    reschedule_cb = ST(3)
;
	}
#line 1096 "EV.xs"
        CHECK_REPEAT (interval);
#line 2409 "EV.c"
#line 1098 "EV.xs"
{
        SvREFCNT_dec (e_fh (w));
        e_fh (w) = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;

        RESET (periodic, w, (w, at, interval, e_fh (w) ? e_periodic_cb : 0));
}
#line 2417 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Periodic_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Periodic_at)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	NV	RETVAL;
	dXSTARG;
	ev_periodic *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_periodic
                  || sv_derived_from (ST(0), "EV::Periodic"))))
          croak ("object is not of type EV::Periodic");
	w = (ev_periodic *)SvPVX (SvRV (ST(0)))
;
#line 1107 "EV.xs"
        RETVAL = ev_periodic_at (w);
#line 2442 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Idle_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Idle_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)))
;
#line 1115 "EV.xs"
        START (idle, w);
#line 2466 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Idle_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Idle_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)))
;
#line 1119 "EV.xs"
        STOP (idle, w);
#line 2489 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Idle_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Idle_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_idle *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_idle
                  || sv_derived_from (ST(0), "EV::Idle"))))
          croak ("object is not of type EV::Idle");
	w = (ev_idle *)SvPVX (SvRV (ST(0)))
;
#line 1123 "EV.xs"
        STOP (idle, w);
        e_destroy (w);
#line 2513 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Prepare_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Prepare_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)))
;
#line 1130 "EV.xs"
        START (prepare, w);
#line 2536 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Prepare_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Prepare_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)))
;
#line 1134 "EV.xs"
        STOP (prepare, w);
#line 2559 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Prepare_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Prepare_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_prepare *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_prepare
                  || sv_derived_from (ST(0), "EV::Prepare"))))
          croak ("object is not of type EV::Prepare");
	w = (ev_prepare *)SvPVX (SvRV (ST(0)))
;
#line 1138 "EV.xs"
        STOP (prepare, w);
        e_destroy (w);
#line 2583 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Check_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Check_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)))
;
#line 1145 "EV.xs"
        START (check, w);
#line 2606 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Check_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Check_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)))
;
#line 1149 "EV.xs"
        STOP (check, w);
#line 2629 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Check_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Check_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_check *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_check
                  || sv_derived_from (ST(0), "EV::Check"))))
          croak ("object is not of type EV::Check");
	w = (ev_check *)SvPVX (SvRV (ST(0)))
;
#line 1153 "EV.xs"
        STOP (check, w);
        e_destroy (w);
#line 2653 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Fork_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Fork_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)))
;
#line 1160 "EV.xs"
        START (fork, w);
#line 2676 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Fork_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Fork_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)))
;
#line 1164 "EV.xs"
        STOP (fork, w);
#line 2699 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Fork_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Fork_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_fork *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_fork
                  || sv_derived_from (ST(0), "EV::Fork"))))
          croak ("object is not of type EV::Fork");
	w = (ev_fork *)SvPVX (SvRV (ST(0)))
;
#line 1168 "EV.xs"
        STOP (fork, w);
        e_destroy (w);
#line 2723 "EV.c"
    }
    XSRETURN_EMPTY;
}

#if CLEANUP_ENABLED
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_EV__Cleanup_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Cleanup_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_cleanup *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_cleanup
                  || sv_derived_from (ST(0), "EV::Cleanup"))))
          croak ("object is not of type EV::Cleanup");
	w = (ev_cleanup *)SvPVX (SvRV (ST(0)))
;
#line 1177 "EV.xs"
        START (cleanup, w);
#line 2749 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Cleanup_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Cleanup_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_cleanup *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_cleanup
                  || sv_derived_from (ST(0), "EV::Cleanup"))))
          croak ("object is not of type EV::Cleanup");
	w = (ev_cleanup *)SvPVX (SvRV (ST(0)))
;
#line 1181 "EV.xs"
        STOP (cleanup, w);
#line 2772 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Cleanup_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Cleanup_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_cleanup *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_cleanup
                  || sv_derived_from (ST(0), "EV::Cleanup"))))
          croak ("object is not of type EV::Cleanup");
	w = (ev_cleanup *)SvPVX (SvRV (ST(0)))
;
#line 1185 "EV.xs"
        STOP (cleanup, w);
        SvREFCNT_inc (w->loop); /* has been dec'ed on creation */
        e_destroy (w);
#line 2797 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Cleanup_keepalive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Cleanup_keepalive)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_value= 0");
    {
	int	RETVAL;
	dXSTARG;
	ev_watcher *	w;
	SV *	new_value;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_watcher
                  || sv_derived_from (ST(0), "EV::Watcher"))))
          croak ("object is not of type EV::Watcher");
	w = (ev_watcher *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_value = 0;
	else {
	    new_value = ST(1)
;
	}
#line 1191 "EV.xs"
        RETVAL = 1;
#line 2830 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#if EV_CHILD_ENABLE
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_EV__Child_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Child_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)))
;
#line 1203 "EV.xs"
        START (child, w);
#line 2858 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Child_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Child_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)))
;
#line 1207 "EV.xs"
        STOP (child, w);
#line 2881 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Child_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Child_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)))
;
#line 1211 "EV.xs"
        STOP (child, w);
        e_destroy (w);
#line 2905 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Child_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Child_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "w, pid, trace");
    {
	ev_child *	w;
	int	pid = (int)SvIV(ST(1))
;
	int	trace = (int)SvIV(ST(2))
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)))
;
#line 1216 "EV.xs"
        RESET (child, w, (w, pid, trace));
#line 2932 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Child_pid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Child_pid)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	int	RETVAL;
	dXSTARG;
	ev_child *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_child
                  || sv_derived_from (ST(0), "EV::Child"))))
          croak ("object is not of type EV::Child");
	w = (ev_child *)SvPVX (SvRV (ST(0)))
;
#line 1223 "EV.xs"
        RETVAL = ix == 0 ? w->pid
               : ix == 1 ? w->rpid
               :           w->rstatus;
#line 2960 "EV.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_EV__Stat_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;
#line 1235 "EV.xs"
        START (stat, w);
#line 2985 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Stat_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;
#line 1239 "EV.xs"
        STOP (stat, w);
#line 3008 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Stat_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;
#line 1243 "EV.xs"
        STOP (stat, w);
        e_destroy (w);
#line 3032 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Stat_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "w, path, interval");
    {
	ev_stat *	w;
	SV *	path = ST(1)
;
	NV	interval = (NV)SvNV(ST(2))
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;
#line 1248 "EV.xs"
{
        sv_setsv (e_fh (w), path);
	RESET (stat, w, (w, SvPVbyte_nolen (e_fh (w)), interval));
}
#line 3062 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Stat_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_path)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_path= 0");
    {
	SV *	RETVAL;
	ev_stat *	w;
	SV *	new_path;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_path = 0;
	else {
	    new_path = ST(1)
;
	}
#line 1255 "EV.xs"
{
        RETVAL = SvREFCNT_inc (e_fh (w));

        if (items > 1)
          {
            SvREFCNT_dec (e_fh (w));
            e_fh (w) = newSVsv (new_path);
            RESET (stat, w, (w, SvPVbyte_nolen (e_fh (w)), w->interval));
          }
}
#line 3103 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Stat_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_interval)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "w, new_interval= 0.");
    {
	NV	RETVAL;
	dXSTARG;
	ev_stat *	w;
	NV	new_interval;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;

	if (items < 2)
	    new_interval = 0.;
	else {
	    new_interval = (NV)SvNV(ST(1))
;
	}
#line 1270 "EV.xs"
{
        RETVAL = w->interval;

        if (items > 1)
          RESET (stat, w, (w, SvPVbyte_nolen (e_fh (w)), new_interval));
}
#line 3143 "EV.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Stat_prev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Stat_prev)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	ev_stat *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_stat
                  || sv_derived_from (ST(0), "EV::Stat"))))
          croak ("object is not of type EV::Stat");
	w = (ev_stat *)SvPVX (SvRV (ST(0)))
;
#line 1284 "EV.xs"
{
	ev_statdata *s = ix ? &w->attr : &w->prev;

        if (ix == 1)
          ev_stat_stat (e_loop (w), w);
        else if (!s->st_nlink)
          errno = ENOENT;

        PL_statcache.st_dev   = s->st_nlink;
        PL_statcache.st_ino   = s->st_ino;
        PL_statcache.st_mode  = s->st_mode;
        PL_statcache.st_nlink = s->st_nlink;
        PL_statcache.st_uid   = s->st_uid;
        PL_statcache.st_gid   = s->st_gid;
        PL_statcache.st_rdev  = s->st_rdev;
        PL_statcache.st_size  = s->st_size;
        PL_statcache.st_atime = s->st_atime;
        PL_statcache.st_mtime = s->st_mtime;
        PL_statcache.st_ctime = s->st_ctime;

        if (GIMME_V == G_SCALAR)
          XPUSHs (boolSV (s->st_nlink));
        else if (GIMME_V == G_ARRAY && s->st_nlink)
          {
            EXTEND (SP, 13);
            PUSHs (sv_2mortal (newSViv (s->st_dev)));
            PUSHs (sv_2mortal (newSViv (s->st_ino)));
            PUSHs (sv_2mortal (newSVuv (s->st_mode)));
            PUSHs (sv_2mortal (newSVuv (s->st_nlink)));
            PUSHs (sv_2mortal (newSViv (s->st_uid)));
            PUSHs (sv_2mortal (newSViv (s->st_gid)));
            PUSHs (sv_2mortal (newSViv (s->st_rdev)));
            PUSHs (sv_2mortal (newSVnv ((NV)s->st_size)));
            PUSHs (sv_2mortal (newSVnv (s->st_atime)));
            PUSHs (sv_2mortal (newSVnv (s->st_mtime)));
            PUSHs (sv_2mortal (newSVnv (s->st_ctime)));
            PUSHs (sv_2mortal (newSVuv (4096)));
            PUSHs (sv_2mortal (newSVnv ((NV)((s->st_size + 4095) / 4096))));
          }
}
#line 3209 "EV.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_EV__Embed_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;
#line 1329 "EV.xs"
        START (embed, w);
#line 3233 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Embed_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;
#line 1333 "EV.xs"
        STOP (embed, w);
#line 3256 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Embed_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;
#line 1337 "EV.xs"
        STOP (embed, w);
        e_destroy (w);
#line 3280 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Embed_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "w, loop");
    {
	ev_embed *	w;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop || sv_derived_from (ST(1), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(1)))
;
#line 1342 "EV.xs"
{
        sv_setsv (e_fh (w), ST (1));
	RESET (embed, w, (w, loop));
}
#line 3313 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Embed_other); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_other)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;
#line 1349 "EV.xs"
        RETVAL = newSVsv (e_fh (w));
#line 3337 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Embed_sweep); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Embed_sweep)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_embed *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_embed
                  || sv_derived_from (ST(0), "EV::Embed"))))
          croak ("object is not of type EV::Embed");
	w = (ev_embed *)SvPVX (SvRV (ST(0)))
;

	ev_embed_sweep(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Async_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Async_start)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)))
;
#line 1360 "EV.xs"
        START (async, w);
#line 3384 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Async_stop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Async_stop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)))
;
#line 1364 "EV.xs"
        STOP (async, w);
#line 3407 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Async_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Async_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)))
;
#line 1368 "EV.xs"
        STOP (async, w);
        e_destroy (w);
#line 3431 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Async_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Async_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)))
;

	ev_async_send(e_loop (w), w);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Async_async_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Async_async_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "w");
    {
	SV *	RETVAL;
	ev_async *	w;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_async
                  || sv_derived_from (ST(0), "EV::Async"))))
          croak ("object is not of type EV::Async");
	w = (ev_async *)SvPVX (SvRV (ST(0)))
;
#line 1376 "EV.xs"
        RETVAL = boolSV (ev_async_pending (w));
#line 3477 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifndef EV_NO_LOOPS
#define XSubPPtmpAAAE 1


XS_EUPXS(XS_EV__Loop_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "klass, flags= 0");
    {
	SV *	RETVAL;
	SV *	klass = ST(0)
;
	unsigned int	flags;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 1386 "EV.xs"
{
	struct ev_loop *loop = ev_loop_new (flags);

        if (!loop)
          XSRETURN_UNDEF;

        RETVAL = sv_bless (newRV_noinc (newSViv (PTR2IV (loop))), stash_loop);
}
#line 3515 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1399 "EV.xs"
        /* 1. the default loop shouldn't be freed by destroying it's perl loop object */
        /* 2. not doing so helps avoid many global destruction bugs in perl, too */
        if (loop != evapi.default_loop)
          ev_loop_destroy (loop);
#line 3542 "EV.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_loop_fork); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_loop_fork)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_loop_fork(loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_now); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_now)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	NV	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	RETVAL = ev_now(loop);
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_now_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_now_update)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_now_update(loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_suspend)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_suspend(loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_resume(loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_set_io_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_set_io_collect_interval)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "loop, interval");
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1))
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_set_io_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_set_timeout_collect_interval); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_set_timeout_collect_interval)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "loop, interval");
    {
	struct ev_loop *	loop;
	NV	interval = (NV)SvNV(ST(1))
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_set_timeout_collect_interval(loop, interval);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_backend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_backend)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	RETVAL = ev_backend(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_verify)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_verify(loop);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_iteration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_iteration)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	RETVAL = ev_iteration(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_depth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_depth)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	RETVAL = ev_depth(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_run)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, flags= 0");
    {
	int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;
	int	flags;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

	RETVAL = ev_run(loop, flags);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_break); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_break)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "loop, how= 1");
    {
	struct ev_loop *	loop;
	int	how;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	if (items < 2)
	    how = 1;
	else {
	    how = (int)SvIV(ST(1))
;
	}

	ev_break(loop, how);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_feed_fd_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_feed_fd_event)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "loop, fd, revents= EV_NONE");
    {
	struct ev_loop *	loop;
	int	fd = (int)SvIV(ST(1))
;
	int	revents;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	if (items < 3)
	    revents = EV_NONE;
	else {
	    revents = (int)SvIV(ST(2))
;
	}

	ev_feed_fd_event(loop, fd, revents);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_EV__Loop_pending_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_pending_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	unsigned int	RETVAL;
	dXSTARG;
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	RETVAL = ev_pending_count(loop);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_invoke_pending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_invoke_pending)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "loop");
    {
	struct ev_loop *	loop;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	ev_invoke_pending(loop);
    }
    XSRETURN_EMPTY;
}

#if 0
#define XSubPPtmpAAAF 1


XS_EUPXS(XS_EV__Loop_feed_signal_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_feed_signal_event)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "loop, signal");
    {
	struct ev_loop *	loop;
	SV *	signal = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1450 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        ev_feed_signal_event (loop, signum);
}
#line 3963 "EV.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_EV__Loop_io); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_io)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, fh, events, cb");
    {
	ev_io *	RETVAL;
	struct ev_loop *	loop;
	SV *	fh = ST(1)
;
	int	events = (int)SvIV(ST(2))
;
	SV *	cb = ST(3)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1463 "EV.xs"
{
	int fd = s_fileno (fh, events & EV_WRITE);
        CHECK_FD (fh, fd);

        RETVAL = e_new (sizeof (ev_io), cb, ST (0));
        e_fh (RETVAL) = newSVsv (fh);
        ev_io_set (RETVAL, fd, events);
        if (!ix) START (io, RETVAL);
}
#line 4002 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_io);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_timer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_timer)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, after, repeat, cb");
    {
	ev_timer *	RETVAL;
	struct ev_loop *	loop;
	NV	after = (NV)SvNV(ST(1))
;
	NV	repeat = (NV)SvNV(ST(2))
;
	SV *	cb = ST(3)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1479 "EV.xs"
        CHECK_REPEAT (repeat);
#line 4038 "EV.c"
#line 1481 "EV.xs"
        RETVAL = e_new (sizeof (ev_timer), cb, ST (0));
        ev_timer_set (RETVAL, after, repeat);
        if (!ix) START (timer, RETVAL);
#line 4043 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_timer);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_periodic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_periodic)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 5)
       croak_xs_usage(cv,  "loop, at, interval, reschedule_cb, cb");
    {
	SV *	RETVAL;
	struct ev_loop *	loop;
	NV	at = (NV)SvNV(ST(1))
;
	NV	interval = (NV)SvNV(ST(2))
;
	SV *	reschedule_cb = ST(3)
;
	SV *	cb = ST(4)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1491 "EV.xs"
        CHECK_REPEAT (interval);
#line 4081 "EV.c"
#line 1493 "EV.xs"
{
	ev_periodic *w;
        w = e_new (sizeof (ev_periodic), cb, ST (0));
        e_fh (w) = SvTRUE (reschedule_cb) ? newSVsv (reschedule_cb) : 0;
        ev_periodic_set (w, at, interval, e_fh (w) ? e_periodic_cb : 0);
        RETVAL = e_bless ((ev_watcher *)w, stash_periodic);
        if (!ix) START (periodic, w);
}
#line 4091 "EV.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_signal)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "loop, signal, cb");
    {
	ev_signal *	RETVAL;
	struct ev_loop *	loop;
	SV *	signal = ST(1)
;
	SV *	cb = ST(2)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1508 "EV.xs"
{
	Signal signum = s_signum (signal);
        CHECK_SIG (signal, signum);

        RETVAL = e_new (sizeof (ev_signal), cb, ST (0));
        ev_signal_set (RETVAL, signum);
        if (!ix) START_SIGNAL (RETVAL);
}
#line 4128 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_signal);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_idle)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_idle *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1523 "EV.xs"
        RETVAL = e_new (sizeof (ev_idle), cb, ST (0));
        ev_idle_set (RETVAL);
        if (!ix) START (idle, RETVAL);
#line 4162 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_idle);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_prepare)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_prepare *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1533 "EV.xs"
        RETVAL = e_new (sizeof (ev_prepare), cb, ST (0));
        ev_prepare_set (RETVAL);
        if (!ix) START (prepare, RETVAL);
#line 4196 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_prepare);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_check)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_check *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1543 "EV.xs"
        RETVAL = e_new (sizeof (ev_check), cb, ST (0));
        ev_check_set (RETVAL);
        if (!ix) START (check, RETVAL);
#line 4230 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_check);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_fork); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_fork)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_fork *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1553 "EV.xs"
        RETVAL = e_new (sizeof (ev_fork), cb, ST (0));
        ev_fork_set (RETVAL);
        if (!ix) START (fork, RETVAL);
#line 4264 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_fork);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if CLEANUP_ENABLED
#define XSubPPtmpAAAG 1


XS_EUPXS(XS_EV__Loop_cleanup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_cleanup)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_cleanup *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1565 "EV.xs"
        RETVAL = e_new (sizeof (ev_cleanup), cb, ST (0));
        SvREFCNT_dec (RETVAL->loop); /* must not keep loop object alive */
        ev_cleanup_set (RETVAL);
        if (!ix) START (cleanup, RETVAL);
#line 4302 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_cleanup);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_EV__Loop_child); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_child)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, pid, trace, cb");
    {
	ev_child *	RETVAL;
	struct ev_loop *	loop;
	int	pid = (int)SvIV(ST(1))
;
	int	trace = (int)SvIV(ST(2))
;
	SV *	cb = ST(3)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1578 "EV.xs"
#if EV_CHILD_ENABLE
        RETVAL = e_new (sizeof (ev_child), cb, ST (0));
        ev_child_set (RETVAL, pid, trace);
        if (!ix) START (child, RETVAL);
#else
        croak ("EV::child watchers not supported on this platform");
#endif
#line 4345 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_child);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_stat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 4)
       croak_xs_usage(cv,  "loop, path, interval, cb");
    {
	ev_stat *	RETVAL;
	struct ev_loop *	loop;
	SV *	path = ST(1)
;
	NV	interval = (NV)SvNV(ST(2))
;
	SV *	cb = ST(3)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1592 "EV.xs"
        RETVAL = e_new (sizeof (ev_stat), cb, ST (0));
        e_fh (RETVAL) = newSVsv (path);
        ev_stat_set (RETVAL, SvPVbyte_nolen (e_fh (RETVAL)), interval);
        if (!ix) START (stat, RETVAL);
#line 4384 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_stat);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_embed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_embed)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "loop, other, cb= 0");
    {
	ev_embed *	RETVAL;
	struct ev_loop *	loop;
	struct ev_loop *	other;
	SV *	cb;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;

	if (!(SvROK (ST(1)) && SvOBJECT (SvRV (ST(1)))
              && (SvSTASH (SvRV (ST(1))) == stash_loop || sv_derived_from (ST(1), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	other = (struct ev_loop *)SvIVX (SvRV (ST(1)))
;

	if (items < 3)
	    cb = 0;
	else {
	    cb = ST(2)
;
	}
#line 1603 "EV.xs"
{
        if (!(ev_backend (other) & ev_embeddable_backends ()))
          croak ("passed loop is not embeddable via EV::embed,");

        RETVAL = e_new (sizeof (ev_embed), cb, ST (0));
        e_fh (RETVAL) = newSVsv (ST (1));
        ev_embed_set (RETVAL, other);
        if (!ix) START (embed, RETVAL);
}
#line 4437 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_embed);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_async); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_async)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "loop, cb");
    {
	ev_async *	RETVAL;
	struct ev_loop *	loop;
	SV *	cb = ST(1)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1619 "EV.xs"
        RETVAL = e_new (sizeof (ev_async), cb, ST (0));
        ev_async_set (RETVAL);
        if (!ix) START (async, RETVAL);
#line 4471 "EV.c"
	{
	    SV * RETVALSV;
	    RETVALSV = e_bless ((struct ev_watcher *)RETVAL, stash_async);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_EV__Loop_once); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_EV__Loop_once)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "loop, fh, events, timeout, cb");
    {
	struct ev_loop *	loop;
	SV *	fh = ST(1)
;
	int	events = (int)SvIV(ST(2))
;
	SV *	timeout = ST(3)
;
	SV *	cb = ST(4)
;

	if (!(SvROK (ST(0)) && SvOBJECT (SvRV (ST(0)))
              && (SvSTASH (SvRV (ST(0))) == stash_loop || sv_derived_from (ST(0), "EV::Loop"))))
          croak ("object is not of type EV::Loop");
	loop = (struct ev_loop *)SvIVX (SvRV (ST(0)))
;
#line 1627 "EV.xs"
        ev_once (
           loop,
           s_fileno (fh, events & EV_WRITE), events,
           SvOK (timeout) ? SvNV (timeout) : -1.,
           e_once_cb,
           newSVsv (cb)
        );
#line 4513 "EV.c"
    }
    XSRETURN_EMPTY;
}

#endif
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_EV); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_EV)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("EV::default_loop", XS_EV_default_loop, file, ";$");
        (void)newXSproto_portable("EV::default_destroy", XS_EV_default_destroy, file, "");
        (void)newXSproto_portable("EV::supported_backends", XS_EV_supported_backends, file, "");
        (void)newXSproto_portable("EV::recommended_backends", XS_EV_recommended_backends, file, "");
        (void)newXSproto_portable("EV::embeddable_backends", XS_EV_embeddable_backends, file, "");
        (void)newXSproto_portable("EV::sleep", XS_EV_sleep, file, "$");
        (void)newXSproto_portable("EV::time", XS_EV_time, file, "");
        (void)newXSproto_portable("EV::feed_signal", XS_EV_feed_signal, file, "$");
        (void)newXSproto_portable("EV::now", XS_EV_now, file, "");
        (void)newXSproto_portable("EV::now_update", XS_EV_now_update, file, "");
        (void)newXSproto_portable("EV::suspend", XS_EV_suspend, file, "");
        (void)newXSproto_portable("EV::resume", XS_EV_resume, file, "");
        (void)newXSproto_portable("EV::backend", XS_EV_backend, file, "");
        cv = newXSproto_portable("EV::loop_verify", XS_EV_verify, file, "");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::verify", XS_EV_verify, file, "");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::iteration", XS_EV_iteration, file, "");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::loop_count", XS_EV_iteration, file, "");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::depth", XS_EV_depth, file, "");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::loop_depth", XS_EV_depth, file, "");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("EV::set_io_collect_interval", XS_EV_set_io_collect_interval, file, "$");
        (void)newXSproto_portable("EV::set_timeout_collect_interval", XS_EV_set_timeout_collect_interval, file, "$");
        cv = newXSproto_portable("EV::loop", XS_EV_run, file, ";$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::run", XS_EV_run, file, ";$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::break", XS_EV_break, file, ";$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::unloop", XS_EV_break, file, ";$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("EV::feed_fd_event", XS_EV_feed_fd_event, file, "$;$");
        (void)newXSproto_portable("EV::feed_signal_event", XS_EV_feed_signal_event, file, "$");
        (void)newXSproto_portable("EV::pending_count", XS_EV_pending_count, file, "");
        (void)newXSproto_portable("EV::invoke_pending", XS_EV_invoke_pending, file, "");
        cv = newXSproto_portable("EV::_ae_io", XS_EV_io, file, "$$$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("EV::io", XS_EV_io, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::io_ns", XS_EV_io, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::timer", XS_EV_timer, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::timer_ns", XS_EV_timer, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::periodic", XS_EV_periodic, file, "$$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::periodic_ns", XS_EV_periodic, file, "$$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::signal", XS_EV_signal, file, "$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::signal_ns", XS_EV_signal, file, "$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::idle", XS_EV_idle, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::idle_ns", XS_EV_idle, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::prepare", XS_EV_prepare, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::prepare_ns", XS_EV_prepare, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::check", XS_EV_check, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::check_ns", XS_EV_check, file, "$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::fork", XS_EV_fork, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::fork_ns", XS_EV_fork, file, "$");
        XSANY.any_i32 = 1;
#if XSubPPtmpAAAA
        cv = newXSproto_portable("EV::cleanup", XS_EV_cleanup, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::cleanup_ns", XS_EV_cleanup, file, "$");
        XSANY.any_i32 = 1;
#endif
        cv = newXSproto_portable("EV::child", XS_EV_child, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::child_ns", XS_EV_child, file, "$$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("EV::stat", XS_EV_stat, file, "$$$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::stat_ns", XS_EV_stat, file, "$$$");
        XSANY.any_i32 = 1;
#if XSubPPtmpAAAB
        cv = newXSproto_portable("EV::embed", XS_EV_embed, file, "$;$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::embed_ns", XS_EV_embed, file, "$;$");
        XSANY.any_i32 = 1;
#endif
        cv = newXSproto_portable("EV::async", XS_EV_async, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("EV::async_ns", XS_EV_async, file, "$");
        XSANY.any_i32 = 1;
        (void)newXSproto_portable("EV::once", XS_EV_once, file, "$$$$");
        newXS_deffile("EV::Watcher::is_active", XS_EV__Watcher_is_active);
        newXS_deffile("EV::Watcher::is_pending", XS_EV__Watcher_is_pending);
        newXS_deffile("EV::Watcher::invoke", XS_EV__Watcher_invoke);
        newXS_deffile("EV::Watcher::clear_pending", XS_EV__Watcher_clear_pending);
        newXS_deffile("EV::Watcher::feed_event", XS_EV__Watcher_feed_event);
        newXS_deffile("EV::Watcher::keepalive", XS_EV__Watcher_keepalive);
        newXS_deffile("EV::Watcher::cb", XS_EV__Watcher_cb);
        newXS_deffile("EV::Watcher::data", XS_EV__Watcher_data);
        newXS_deffile("EV::Watcher::loop", XS_EV__Watcher_loop);
        newXS_deffile("EV::Watcher::priority", XS_EV__Watcher_priority);
        newXS_deffile("EV::IO::start", XS_EV__IO_start);
        newXS_deffile("EV::IO::stop", XS_EV__IO_stop);
        newXS_deffile("EV::IO::DESTROY", XS_EV__IO_DESTROY);
        newXS_deffile("EV::IO::set", XS_EV__IO_set);
        newXS_deffile("EV::IO::fh", XS_EV__IO_fh);
        newXS_deffile("EV::IO::events", XS_EV__IO_events);
        newXS_deffile("EV::Signal::start", XS_EV__Signal_start);
        newXS_deffile("EV::Signal::stop", XS_EV__Signal_stop);
        newXS_deffile("EV::Signal::DESTROY", XS_EV__Signal_DESTROY);
        newXS_deffile("EV::Signal::set", XS_EV__Signal_set);
        newXS_deffile("EV::Signal::signal", XS_EV__Signal_signal);
        newXS_deffile("EV::Timer::start", XS_EV__Timer_start);
        newXS_deffile("EV::Timer::stop", XS_EV__Timer_stop);
        newXS_deffile("EV::Timer::again", XS_EV__Timer_again);
        newXS_deffile("EV::Timer::remaining", XS_EV__Timer_remaining);
        newXS_deffile("EV::Timer::DESTROY", XS_EV__Timer_DESTROY);
        newXS_deffile("EV::Timer::set", XS_EV__Timer_set);
        newXS_deffile("EV::Periodic::start", XS_EV__Periodic_start);
        newXS_deffile("EV::Periodic::stop", XS_EV__Periodic_stop);
        newXS_deffile("EV::Periodic::again", XS_EV__Periodic_again);
        newXS_deffile("EV::Periodic::DESTROY", XS_EV__Periodic_DESTROY);
        newXS_deffile("EV::Periodic::set", XS_EV__Periodic_set);
        newXS_deffile("EV::Periodic::at", XS_EV__Periodic_at);
        newXS_deffile("EV::Idle::start", XS_EV__Idle_start);
        newXS_deffile("EV::Idle::stop", XS_EV__Idle_stop);
        newXS_deffile("EV::Idle::DESTROY", XS_EV__Idle_DESTROY);
        newXS_deffile("EV::Prepare::start", XS_EV__Prepare_start);
        newXS_deffile("EV::Prepare::stop", XS_EV__Prepare_stop);
        newXS_deffile("EV::Prepare::DESTROY", XS_EV__Prepare_DESTROY);
        newXS_deffile("EV::Check::start", XS_EV__Check_start);
        newXS_deffile("EV::Check::stop", XS_EV__Check_stop);
        newXS_deffile("EV::Check::DESTROY", XS_EV__Check_DESTROY);
        newXS_deffile("EV::Fork::start", XS_EV__Fork_start);
        newXS_deffile("EV::Fork::stop", XS_EV__Fork_stop);
        newXS_deffile("EV::Fork::DESTROY", XS_EV__Fork_DESTROY);
#if XSubPPtmpAAAC
        newXS_deffile("EV::Cleanup::start", XS_EV__Cleanup_start);
        newXS_deffile("EV::Cleanup::stop", XS_EV__Cleanup_stop);
        newXS_deffile("EV::Cleanup::DESTROY", XS_EV__Cleanup_DESTROY);
        newXS_deffile("EV::Cleanup::keepalive", XS_EV__Cleanup_keepalive);
#endif
#if XSubPPtmpAAAD
        newXS_deffile("EV::Child::start", XS_EV__Child_start);
        newXS_deffile("EV::Child::stop", XS_EV__Child_stop);
        newXS_deffile("EV::Child::DESTROY", XS_EV__Child_DESTROY);
        newXS_deffile("EV::Child::set", XS_EV__Child_set);
        cv = newXS_deffile("EV::Child::pid", XS_EV__Child_pid);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Child::rpid", XS_EV__Child_pid);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Child::rstatus", XS_EV__Child_pid);
        XSANY.any_i32 = 2;
#endif
        newXS_deffile("EV::Stat::start", XS_EV__Stat_start);
        newXS_deffile("EV::Stat::stop", XS_EV__Stat_stop);
        newXS_deffile("EV::Stat::DESTROY", XS_EV__Stat_DESTROY);
        newXS_deffile("EV::Stat::set", XS_EV__Stat_set);
        newXS_deffile("EV::Stat::path", XS_EV__Stat_path);
        newXS_deffile("EV::Stat::interval", XS_EV__Stat_interval);
        cv = newXS_deffile("EV::Stat::attr", XS_EV__Stat_prev);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("EV::Stat::prev", XS_EV__Stat_prev);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Stat::stat", XS_EV__Stat_prev);
        XSANY.any_i32 = 1;
        newXS_deffile("EV::Embed::start", XS_EV__Embed_start);
        newXS_deffile("EV::Embed::stop", XS_EV__Embed_stop);
        newXS_deffile("EV::Embed::DESTROY", XS_EV__Embed_DESTROY);
        newXS_deffile("EV::Embed::set", XS_EV__Embed_set);
        newXS_deffile("EV::Embed::other", XS_EV__Embed_other);
        newXS_deffile("EV::Embed::sweep", XS_EV__Embed_sweep);
        newXS_deffile("EV::Async::start", XS_EV__Async_start);
        newXS_deffile("EV::Async::stop", XS_EV__Async_stop);
        newXS_deffile("EV::Async::DESTROY", XS_EV__Async_DESTROY);
        newXS_deffile("EV::Async::send", XS_EV__Async_send);
        newXS_deffile("EV::Async::async_pending", XS_EV__Async_async_pending);
#if XSubPPtmpAAAE
        newXS_deffile("EV::Loop::new", XS_EV__Loop_new);
        newXS_deffile("EV::Loop::DESTROY", XS_EV__Loop_DESTROY);
        newXS_deffile("EV::Loop::loop_fork", XS_EV__Loop_loop_fork);
        newXS_deffile("EV::Loop::now", XS_EV__Loop_now);
        newXS_deffile("EV::Loop::now_update", XS_EV__Loop_now_update);
        newXS_deffile("EV::Loop::suspend", XS_EV__Loop_suspend);
        newXS_deffile("EV::Loop::resume", XS_EV__Loop_resume);
        newXS_deffile("EV::Loop::set_io_collect_interval", XS_EV__Loop_set_io_collect_interval);
        newXS_deffile("EV::Loop::set_timeout_collect_interval", XS_EV__Loop_set_timeout_collect_interval);
        newXS_deffile("EV::Loop::backend", XS_EV__Loop_backend);
        cv = newXS_deffile("EV::Loop::loop_verify", XS_EV__Loop_verify);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::verify", XS_EV__Loop_verify);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::iteration", XS_EV__Loop_iteration);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::loop_count", XS_EV__Loop_iteration);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::depth", XS_EV__Loop_depth);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::loop_depth", XS_EV__Loop_depth);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::loop", XS_EV__Loop_run);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::run", XS_EV__Loop_run);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::break", XS_EV__Loop_break);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::unloop", XS_EV__Loop_break);
        XSANY.any_i32 = 1;
        newXS_deffile("EV::Loop::feed_fd_event", XS_EV__Loop_feed_fd_event);
        newXS_deffile("EV::Loop::pending_count", XS_EV__Loop_pending_count);
        newXS_deffile("EV::Loop::invoke_pending", XS_EV__Loop_invoke_pending);
#if XSubPPtmpAAAF
        newXS_deffile("EV::Loop::feed_signal_event", XS_EV__Loop_feed_signal_event);
#endif
        cv = newXS_deffile("EV::Loop::io", XS_EV__Loop_io);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::io_ns", XS_EV__Loop_io);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::timer", XS_EV__Loop_timer);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::timer_ns", XS_EV__Loop_timer);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::periodic", XS_EV__Loop_periodic);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::periodic_ns", XS_EV__Loop_periodic);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::signal", XS_EV__Loop_signal);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::signal_ns", XS_EV__Loop_signal);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::idle", XS_EV__Loop_idle);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::idle_ns", XS_EV__Loop_idle);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::prepare", XS_EV__Loop_prepare);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::prepare_ns", XS_EV__Loop_prepare);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::check", XS_EV__Loop_check);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::check_ns", XS_EV__Loop_check);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::fork", XS_EV__Loop_fork);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::fork_ns", XS_EV__Loop_fork);
        XSANY.any_i32 = 1;
#if XSubPPtmpAAAG
        cv = newXS_deffile("EV::Loop::cleanup", XS_EV__Loop_cleanup);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::cleanup_ns", XS_EV__Loop_cleanup);
        XSANY.any_i32 = 1;
#endif
        cv = newXS_deffile("EV::Loop::child", XS_EV__Loop_child);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::child_ns", XS_EV__Loop_child);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::stat", XS_EV__Loop_stat);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::stat_ns", XS_EV__Loop_stat);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::embed", XS_EV__Loop_embed);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::embed_ns", XS_EV__Loop_embed);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("EV::Loop::async", XS_EV__Loop_async);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("EV::Loop::async_ns", XS_EV__Loop_async);
        XSANY.any_i32 = 1;
        newXS_deffile("EV::Loop::once", XS_EV__Loop_once);
#endif

    /* Initialisation Section */

#line 369 "EV.xs"
{
  HV *stash = gv_stashpv ("EV", 1);

  static const struct {
    const char *name;
    IV iv;
  } *civ, const_iv[] = {
#   define const_iv(pfx, name) { # name, (IV) pfx ## name },
    const_iv (EV_, MINPRI)
    const_iv (EV_, MAXPRI)

    const_iv (EV_, UNDEF)
    const_iv (EV_, NONE)
    const_iv (EV_, READ)
    const_iv (EV_, WRITE)
    const_iv (EV_, IO)
    const_iv (EV_, TIMER)
    const_iv (EV_, PERIODIC)
    const_iv (EV_, SIGNAL)
    const_iv (EV_, CHILD)
    const_iv (EV_, STAT)
    const_iv (EV_, IDLE)
    const_iv (EV_, PREPARE)
    /*const_iv (EV_, CHECK) needs special tretament */
    const_iv (EV_, EMBED)
    const_iv (EV_, FORK)
    const_iv (EV_, CLEANUP)
    const_iv (EV_, ASYNC)
    const_iv (EV_, CUSTOM)
    const_iv (EV_, ERROR)

    const_iv (EV, RUN_NOWAIT)
    const_iv (EV, RUN_ONCE)

    const_iv (EV, BREAK_CANCEL)
    const_iv (EV, BREAK_ONE)
    const_iv (EV, BREAK_ALL)
    const_iv (EV, BACKEND_SELECT)
    const_iv (EV, BACKEND_POLL)
    const_iv (EV, BACKEND_EPOLL)
    const_iv (EV, BACKEND_KQUEUE)
    const_iv (EV, BACKEND_DEVPOLL)
    const_iv (EV, BACKEND_PORT)
    const_iv (EV, BACKEND_ALL)
    const_iv (EV, BACKEND_MASK)
    const_iv (EV, FLAG_AUTO)
    const_iv (EV, FLAG_FORKCHECK)
    const_iv (EV, FLAG_SIGNALFD)
    const_iv (EV, FLAG_NOSIGMASK)
    const_iv (EV, FLAG_NOENV)
    const_iv (EV, FLAG_NOINOTIFY)

    const_iv (EV_, VERSION_MAJOR)
    const_iv (EV_, VERSION_MINOR)
#if EV_COMPAT3
    const_iv (EV, FLAG_NOSIGFD) /* compatibility, always 0 */
    const_iv (EV_, TIMEOUT)
    const_iv (EV, LOOP_NONBLOCK)
    const_iv (EV, LOOP_ONESHOT)
    const_iv (EV, UNLOOP_CANCEL)
    const_iv (EV, UNLOOP_ONE)
    const_iv (EV, UNLOOP_ALL)
#endif
  };

  for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ > const_iv; civ--)
    newCONSTSUB (stash, (char *)civ[-1].name, newSViv (civ[-1].iv));

  /* since this clashes with perl CHECK blocks, */
  /* but we are interested in constants, */
  /* and not blocks, we treat CHECK specially. */
  {
    /* the local $^W = 0 takes care of the warning */
    CV *cv = newCONSTSUB (stash, "CHECK", newSViv (EV_CHECK));
    /* now we need to re-set the gv, in case it was hijacked */
    GvCV_set (gv_fetchpv ("EV::CHECK", GV_ADD, SVt_PVCV), cv);
  }

  stash_loop     = gv_stashpv ("EV::Loop"    , 1);
  stash_watcher  = gv_stashpv ("EV::Watcher" , 1);
  stash_io       = gv_stashpv ("EV::IO"      , 1);
  stash_timer    = gv_stashpv ("EV::Timer"   , 1);
  stash_periodic = gv_stashpv ("EV::Periodic", 1);
  stash_signal   = gv_stashpv ("EV::Signal"  , 1);
  stash_idle     = gv_stashpv ("EV::Idle"    , 1);
  stash_prepare  = gv_stashpv ("EV::Prepare" , 1);
  stash_check    = gv_stashpv ("EV::Check"   , 1);
  stash_child    = gv_stashpv ("EV::Child"   , 1);
  stash_embed    = gv_stashpv ("EV::Embed"   , 1);
  stash_stat     = gv_stashpv ("EV::Stat"    , 1);
  stash_fork     = gv_stashpv ("EV::Fork"    , 1);
  stash_cleanup  = gv_stashpv ("EV::Cleanup" , 1);
  stash_async    = gv_stashpv ("EV::Async"   , 1);

  {
    SV *sv = perl_get_sv ("EV::API", TRUE);
             perl_get_sv ("EV::API", TRUE); /* silence 5.10 warning */

    /* the poor man's shared library emulator */
    evapi.ver                  = EV_API_VERSION;
    evapi.rev                  = EV_API_REVISION;
    evapi.sv_fileno            = sv_fileno;
    evapi.sv_signum            = s_signum;
    evapi.supported_backends   = ev_supported_backends ();
    evapi.recommended_backends = ev_recommended_backends ();
    evapi.embeddable_backends  = ev_embeddable_backends ();
    evapi.time_                = ev_time;
    evapi.sleep_               = ev_sleep;
    evapi.loop_new             = ev_loop_new;
    evapi.loop_destroy         = ev_loop_destroy;
    evapi.loop_fork            = ev_loop_fork;
    evapi.iteration            = ev_iteration;
    evapi.depth                = ev_depth;
    evapi.set_userdata         = ev_set_userdata;
    evapi.userdata             = ev_userdata;
    evapi.now                  = ev_now;
    evapi.now_update           = ev_now_update;
    evapi.suspend              = ev_suspend;
    evapi.resume               = ev_resume;
    evapi.backend              = ev_backend;
    evapi.break_               = ev_break;
    evapi.invoke_pending       = ev_invoke_pending;
    evapi.pending_count        = ev_pending_count;
    evapi.verify               = ev_verify;
    evapi.set_loop_release_cb  = ev_set_loop_release_cb;
    evapi.set_invoke_pending_cb= ev_set_invoke_pending_cb;
    evapi.ref                  = ev_ref;
    evapi.unref                = ev_unref;
    evapi.run                  = ev_run;
    evapi.once                 = ev_once;
    evapi.io_start             = ev_io_start;
    evapi.io_stop              = ev_io_stop;
    evapi.timer_start          = ev_timer_start;
    evapi.timer_stop           = ev_timer_stop;
    evapi.timer_again          = ev_timer_again;
    evapi.timer_remaining      = ev_timer_remaining;
    evapi.periodic_start       = ev_periodic_start;
    evapi.periodic_stop        = ev_periodic_stop;
    evapi.signal_start         = ev_signal_start;
    evapi.signal_stop          = ev_signal_stop;
    evapi.idle_start           = ev_idle_start;
    evapi.idle_stop            = ev_idle_stop;
    evapi.prepare_start        = ev_prepare_start;
    evapi.prepare_stop         = ev_prepare_stop;
    evapi.check_start          = ev_check_start;
    evapi.check_stop           = ev_check_stop;
#if EV_CHILD_ENABLE
    evapi.child_start          = ev_child_start;
    evapi.child_stop           = ev_child_stop;
#endif
    evapi.stat_start           = ev_stat_start;
    evapi.stat_stop            = ev_stat_stop;
    evapi.stat_stat            = ev_stat_stat;
    evapi.embed_start          = ev_embed_start;
    evapi.embed_stop           = ev_embed_stop;
    evapi.embed_sweep          = ev_embed_sweep;
    evapi.fork_start           = ev_fork_start;
    evapi.fork_stop            = ev_fork_stop;
    evapi.cleanup_start        = ev_cleanup_start;
    evapi.cleanup_stop         = ev_cleanup_stop;
    evapi.async_start          = ev_async_start;
    evapi.async_stop           = ev_async_stop;
    evapi.async_send           = ev_async_send;
    evapi.clear_pending        = ev_clear_pending;
    evapi.invoke               = ev_invoke;

    sv_setiv (sv, (IV)&evapi);
    SvREADONLY_on (sv);
  }
#if !defined _WIN32 && !defined _MINIX && !EV_NO_ATFORK
#if __linux
  int __register_atfork(void (*prepare) (void), void (*parent) (void), void (*child) (void), void *   __dso_handle);
  __register_atfork (0, 0, default_fork, 0);
#else
  pthread_atfork (0, 0, default_fork);
#endif
#endif
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#endif
#line 5021 "EV.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

